Index: /LMDZ4/trunk/libf/phylmd/conflx.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/conflx.F	(revision 765)
+++ /LMDZ4/trunk/libf/phylmd/conflx.F	(revision 766)
@@ -8,4 +8,5 @@
      s                   kcbot, kctop, kdtop, pmflxr, pmflxs)
 c
+      USE dimphy
       IMPLICIT none
 c======================================================================
@@ -17,6 +18,6 @@
 c         et lessivage des traceurs passifs.
 c======================================================================
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 #include "YOETHF.h"
@@ -214,8 +215,9 @@
      .                   pmfu, pmfd, pen_u, pde_u, pen_d, pde_d,
      .                   dt_con, dq_con, pmflxr, pmflxs)
+      USE dimphy
       IMPLICIT none
 C     ------------------------------------------------------------------
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 #include "YOETHF.h"
@@ -265,4 +267,5 @@
       SAVE firstcal
       DATA firstcal / .TRUE. /
+c$OMP THREADPRIVATE(firstcal)
 C---------------------------------------------------------------------
       IF (firstcal) THEN
@@ -504,4 +507,5 @@
      .           pdmfdp, pmfu, pmfus, pmfuq, pdmfup, pdpmel, plu, plude,
      .           klab,pen_u, pde_u, pen_d, pde_d)
+      USE dimphy
       IMPLICIT none
 C----------------------------------------------------------------------
@@ -510,6 +514,6 @@
 C AND INITIALIZES VALUES FOR UPDRAFTS
 C----------------------------------------------------------------------
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 #include "YOETHF.h"
@@ -629,4 +633,5 @@
       SUBROUTINE flxbase(ptenh, pqenh, pgeoh, paph,
      *     ptu, pqu, plu, ldcum, kcbot, klab)
+      USE dimphy
       IMPLICIT none
 C----------------------------------------------------------------------
@@ -641,6 +646,6 @@
 C (NON ENTRAINING PLUME,I.E.CONSTANT MASSFLUX)
 C----------------------------------------------------------------------
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 #include "YOETHF.h"
@@ -714,4 +719,5 @@
      .     pmful, plude, pdmfup, kcbot, kctop, kctop0, kcum,
      .     pen_u, pde_u)
+      USE dimphy
       IMPLICIT none
 C----------------------------------------------------------------------
@@ -719,6 +725,6 @@
 C FOR CUMULUS PARAMETERIZATION
 C----------------------------------------------------------------------
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 #include "YOETHF.h"
@@ -1018,4 +1024,5 @@
      .  ,  pten, prfl, psfl, pdpmel, ktopm2
      .  ,  pmflxr, pmflxs)
+      USE dimphy
       IMPLICIT none
 C----------------------------------------------------------------------
@@ -1023,11 +1030,11 @@
 C FLUXES IN THE CLOUD LAYER AND IN THE SUBCLOUD LAYER
 C----------------------------------------------------------------------
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 #include "YOETHF.h"
 #include "YOECUMF.h"
 C
-      REAL cevapcu(klev)
+      REAL cevapcu(klon,klev)
 C     -----------------------------------------------------------------
       REAL pqen(klon,klev), pqenh(klon,klev), pqsen(klon,klev)
@@ -1064,6 +1071,8 @@
 c
       DO 101 k=1,klev
-      CEVAPCU(k)=1.93E-6*261.*SQRT(1.E3/(38.3*0.293)
-     1 *SQRT(0.5*(paph(1,k)+paph(1,k+1))/paph(1,klev+1)) ) * 0.5/RG
+        DO i=1,klon
+      CEVAPCU(i,k)=1.93E-6*261.*SQRT(1.E3/(38.3*0.293)
+     1 *SQRT(0.5*(paph(i,k)+paph(i,k+1))/paph(i,klev+1)) ) * 0.5/RG
+        ENDDO
  101  CONTINUE
 c
@@ -1213,5 +1222,5 @@
          IF (zrfl.GT.1.0E-20) THEN
             zrnew=(MAX(0.,SQRT(zrfl/zcucov)-
-     .            CEVAPCU(k)*(paph(i,k+1)-paph(i,k))*
+     .            CEVAPCU(i,k)*(paph(i,k+1)-paph(i,k))*
      .            MAX(0.,pqsen(i,k)-pqen(i,k))))**2*zcucov
             zrmin=zrfl-zcucov*MAX(0.,0.8*pqsen(i,k)-pqen(i,k))
@@ -1262,10 +1271,11 @@
      .  ,  pmfus, pmfds, pmfuq, pmfdq, pmful, pdmfup, pdmfdp
      .  ,  pdpmel, dt_con, dq_con)
+      USE dimphy
       IMPLICIT none
 c----------------------------------------------------------------------
 c calculer les tendances T et Q
 c----------------------------------------------------------------------
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 #include "YOETHF.h"
@@ -1333,4 +1343,5 @@
      .     ldcum, kcbot, kctop, pmfub, prfl, ptd, pqd,
      .     pmfd, pmfds, pmfdq, pdmfdp, kdtop, lddraf)
+      USE dimphy
       IMPLICIT none
 C
@@ -1350,6 +1361,6 @@
 C MOIST ENVIRONMENTAL AIR AND CLOUD AIR.
 C----------------------------------------------------------------------
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 #include "YOETHF.h"
@@ -1444,4 +1455,5 @@
      .           ptd, pqd, pmfd, pmfds, pmfdq, pdmfdp,
      .           lddraf, pen_d, pde_d)
+      USE dimphy
       IMPLICIT none
 C
@@ -1461,6 +1473,6 @@
 C
 C----------------------------------------------------------------------
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 #include "YOETHF.h"
@@ -1559,4 +1571,5 @@
       END
       SUBROUTINE flxadjtq(pp, pt, pq, ldflag, kcall)
+      USE dimphy
       IMPLICIT none
 c======================================================================
@@ -1568,6 +1581,6 @@
 C        kcall=2  EVAPORATION IN DOWNDRAFTS (E.G. CUDLFS,CUDDRAF)
 C
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 C
Index: /LMDZ4/trunk/libf/phylmd/conlmd.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/conlmd.F	(revision 765)
+++ /LMDZ4/trunk/libf/phylmd/conlmd.F	(revision 766)
@@ -4,4 +4,5 @@
       SUBROUTINE conlmd (dtime, paprs, pplay, t, q, conv_q,
      s                   d_t, d_q, rain, snow, ibas, itop)
+      USE dimphy
       IMPLICIT none
 c======================================================================
@@ -10,6 +11,6 @@
 c        Ajustement humide (Manabe) + Ajustement convectif (Kuo)
 c======================================================================
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 #include "YOETHF.h"
@@ -93,4 +94,5 @@
      s                   d_t, d_q, d_ql, rneb,
      s                   rain, snow, ibas, itop)
+      USE dimphy
       IMPLICIT none
 c======================================================================
@@ -105,6 +107,6 @@
 c du modele.
 c======================================================================
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 c
@@ -154,10 +156,14 @@
       INTEGER ncpt
       SAVE ncpt
+c$OMP THREADPRIVATE(ncpt)
       REAL frac(nb) ! valeur de la maille fractionnelle
       SAVE frac
+c$OMP THREADPRIVATE(frac)
       INTEGER opt_cld(nb) ! option pour le modele nuageux
       SAVE opt_cld
+c$OMP THREADPRIVATE(opt_cld)
       LOGICAL appel1er
       SAVE appel1er
+c$OMP THREADPRIVATE(appel1er)
 c
 c Fonctions thermodynamiques:
@@ -301,4 +307,5 @@
      s                    d_t, d_q, d_ql, rneb,
      s                    rain, snow, ibas, itop,accompli,imprim)
+      USE dimphy
       IMPLICIT none
 c======================================================================
@@ -309,6 +316,6 @@
 c        et itop est le haut du plus haut bloc
 c======================================================================
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 c
@@ -1064,4 +1071,5 @@
      s                  d_t, d_q, d_ql, rneb, 
      s                  rain, snow, ibas, itop)
+      USE dimphy
       IMPLICIT none
 c======================================================================
@@ -1071,6 +1079,6 @@
 c N.B. version vectorielle (le 6 oct. 1997)
 c======================================================================
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 c
@@ -1145,4 +1153,5 @@
       LOGICAL appel1er
       SAVE appel1er
+c$OMP THREADPRIVATE(appel1er)
 c
 c Fonctions thermodynamiques
@@ -1587,4 +1596,5 @@
       END
       SUBROUTINE kuofcl(pt, pq, pg, pp, LDCUM, kcbot)
+      USE dimphy
       IMPLICIT none
 c======================================================================
@@ -1603,6 +1613,6 @@
 c kcbot---output-I- Niveau du bas de la convection
 c======================================================================
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 #include "YOETHF.h"
@@ -1688,4 +1698,5 @@
       END
       SUBROUTINE adjtq(pp, pt, pq, LDFLAG, KCALL)
+      USE dimphy
       IMPLICIT none
 c======================================================================
@@ -1706,6 +1717,6 @@
 C        KCALL=2  EVAPORATION IN DOWNDRAFTS (E.G. CUDLFS,CUDDRAF)
 C
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 C
@@ -1797,10 +1808,11 @@
      .                 d_t, d_q, d_ql, rneb,
      .                 rain, snow, ibas, itop)
+      USE dimphy
       IMPLICIT NONE
 c
 c Ajustement humide (Schema de convection de Manabe)
 C.
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 c
@@ -2095,8 +2107,9 @@
      .                 d_t, d_q, d_ql,rneb,
      .                 rain, snow, ibas, itop)
+      USE dimphy
       IMPLICIT NONE
 c
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 c
Index: /LMDZ4/trunk/libf/phylmd/convect1.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/convect1.F	(revision 765)
+++ /LMDZ4/trunk/libf/phylmd/convect1.F	(revision 766)
@@ -107,8 +107,9 @@
 c
 c
+       USE dimphy
       implicit none
 c
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 c
       integer len
Index: /LMDZ4/trunk/libf/phylmd/convect2.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/convect2.F	(revision 765)
+++ /LMDZ4/trunk/libf/phylmd/convect2.F	(revision 766)
@@ -148,8 +148,9 @@
 c
 c
+      USE dimphy
       implicit none
 c
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 c
       integer kmax2,imax2,kmin2,imin2
Index: /LMDZ4/trunk/libf/phylmd/convect3.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/convect3.F	(revision 765)
+++ /LMDZ4/trunk/libf/phylmd/convect3.F	(revision 766)
@@ -18,6 +18,8 @@
 cFleur       Introduction des traceurs dans convect3 le 6 juin 200
 c#################################################################
+      USE dimphy
+
 #include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimphy.h"
       PARAMETER (NA=60)
 
@@ -1341,59 +1343,59 @@
 
 
-c$$$cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
-c$$$         call writeg1d(1,klev,ma,'ma  ','ma  ')
-c$$$          call writeg1d(1,klev,upwd,'upwd  ','upwd  ')
-c$$$          call writeg1d(1,klev,dnwd,'dnwd  ','dnwd  ')
-c$$$          call writeg1d(1,klev,dnwd0,'dnwd0  ','dnwd0  ')
-c$$$          call writeg1d(1,klev,tvp,'tvp  ','tvp  ')
-c$$$          call writeg1d(1,klev,tra(1:klev,3),'tra3  ','tra3  ')
-c$$$          call writeg1d(1,klev,tra(1:klev,4),'tra4  ','tra4  ')
-c$$$          call writeg1d(1,klev,tra(1:klev,5),'tra5  ','tra5  ')
-c$$$          call writeg1d(1,klev,tra(1:klev,6),'tra6  ','tra6  ')
-c$$$          call writeg1d(1,klev,tra(1:klev,7),'tra7  ','tra7  ')
-c$$$          call writeg1d(1,klev,tra(1:klev,8),'tra8  ','tra8  ')
-c$$$          call writeg1d(1,klev,tra(1:klev,9),'tra9  ','tra9  ')
-c$$$          call writeg1d(1,klev,tra(1:klev,10),'tra10','tra10')
-c$$$          call writeg1d(1,klev,tra(1:klev,11),'tra11','tra11')
-c$$$          call writeg1d(1,klev,tra(1:klev,12),'tra12','tra12')
-c$$$          call writeg1d(1,klev,tra(1:klev,13),'tra13','tra13')
-c$$$          call writeg1d(1,klev,tra(1:klev,14),'tra14','tra14')
-c$$$          call writeg1d(1,klev,tra(1:klev,15),'tra15','tra15')
-c$$$          call writeg1d(1,klev,tra(1:klev,16),'tra16','tra16')
-c$$$          call writeg1d(1,klev,tra(1:klev,17),'tra17','tra17')
-c$$$          call writeg1d(1,klev,tra(1:klev,18),'tra18','tra18')
-c$$$          call writeg1d(1,klev,tra(1:klev,19),'tra19','tra19')
-c$$$          call writeg1d(1,klev,tra(1:klev,20),'tra20','tra20 ')
-c$$$          call writeg1d(1,klev,trap(1:klev,1),'trp1','trp1')
-c$$$          call writeg1d(1,klev,trap(1:klev,2),'trp2','trp2')
-c$$$          call writeg1d(1,klev,trap(1:klev,3),'trp3','trp3')
-c$$$          call writeg1d(1,klev,trap(1:klev,4),'trp4','trp4')
-c$$$          call writeg1d(1,klev,trap(1:klev,5),'trp5','trp5')
-c$$$          call writeg1d(1,klev,trap(1:klev,10),'trp10','trp10')
-c$$$          call writeg1d(1,klev,trap(1:klev,12),'trp12','trp12')
-c$$$          call writeg1d(1,klev,trap(1:klev,15),'trp15','trp15')
-c$$$          call writeg1d(1,klev,trap(1:klev,20),'trp20','trp20')
-c$$$          call writeg1d(1,klev,ftra(1:klev,1),'ftr1  ','ftr1  ')
-c$$$          call writeg1d(1,klev,ftra(1:klev,2),'ftr2  ','ftr2  ')
-c$$$          call writeg1d(1,klev,ftra(1:klev,3),'ftr3  ','ftr3  ')
-c$$$          call writeg1d(1,klev,ftra(1:klev,4),'ftr4  ','ftr4  ')
-c$$$          call writeg1d(1,klev,ftra(1:klev,5),'ftr5  ','ftr5  ')
-c$$$          call writeg1d(1,klev,ftra(1:klev,6),'ftr6  ','ftr6  ')
-c$$$          call writeg1d(1,klev,ftra(1:klev,7),'ftr7  ','ftr7  ')
-c$$$          call writeg1d(1,klev,ftra(1:klev,8),'ftr8  ','ftr8  ')
-c$$$          call writeg1d(1,klev,ftra(1:klev,9),'ftr9  ','ftr9  ')
-c$$$          call writeg1d(1,klev,ftra(1:klev,10),'ftr10','ftr10')
-c$$$          call writeg1d(1,klev,ftra(1:klev,11),'ftr11','ftr11')
-c$$$          call writeg1d(1,klev,ftra(1:klev,12),'ftr12','ftr12')
-c$$$          call writeg1d(1,klev,ftra(1:klev,13),'ftr13','ftr13')
-c$$$          call writeg1d(1,klev,ftra(1:klev,14),'ftr14','ftr14')
-c$$$          call writeg1d(1,klev,ftra(1:klev,15),'ftr15','ftr15')
-c$$$          call writeg1d(1,klev,ftra(1:klev,16),'ftr16','ftr16')
-c$$$          call writeg1d(1,klev,ftra(1:klev,17),'ftr17','ftr17')
-c$$$          call writeg1d(1,klev,ftra(1:klev,18),'ftr18','ftr18')
-c$$$          call writeg1d(1,klev,ftra(1:klev,19),'ftr19','ftr19')
-c$$$          call writeg1d(1,klev,ftra(1:klev,20),'ftr20','ftr20 ')
-c$$$          call writeg1d(1,klev,mp,'mp  ','mp ')
-c$$$          call writeg1d(1,klev,Mke,'Mke  ','Mke ')
+c@$$cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
+c@$$         call writeg1d(1,klev,ma,'ma  ','ma  ')
+c@$$          call writeg1d(1,klev,upwd,'upwd  ','upwd  ')
+c@$$          call writeg1d(1,klev,dnwd,'dnwd  ','dnwd  ')
+c@$$          call writeg1d(1,klev,dnwd0,'dnwd0  ','dnwd0  ')
+c@$$          call writeg1d(1,klev,tvp,'tvp  ','tvp  ')
+c@$$          call writeg1d(1,klev,tra(1:klev,3),'tra3  ','tra3  ')
+c@$$          call writeg1d(1,klev,tra(1:klev,4),'tra4  ','tra4  ')
+c@$$          call writeg1d(1,klev,tra(1:klev,5),'tra5  ','tra5  ')
+c@$$          call writeg1d(1,klev,tra(1:klev,6),'tra6  ','tra6  ')
+c@$$          call writeg1d(1,klev,tra(1:klev,7),'tra7  ','tra7  ')
+c@$$          call writeg1d(1,klev,tra(1:klev,8),'tra8  ','tra8  ')
+c@$$          call writeg1d(1,klev,tra(1:klev,9),'tra9  ','tra9  ')
+c@$$          call writeg1d(1,klev,tra(1:klev,10),'tra10','tra10')
+c@$$          call writeg1d(1,klev,tra(1:klev,11),'tra11','tra11')
+c@$$          call writeg1d(1,klev,tra(1:klev,12),'tra12','tra12')
+c@$$          call writeg1d(1,klev,tra(1:klev,13),'tra13','tra13')
+c@$$          call writeg1d(1,klev,tra(1:klev,14),'tra14','tra14')
+c@$$          call writeg1d(1,klev,tra(1:klev,15),'tra15','tra15')
+c@$$          call writeg1d(1,klev,tra(1:klev,16),'tra16','tra16')
+c@$$          call writeg1d(1,klev,tra(1:klev,17),'tra17','tra17')
+c@$$          call writeg1d(1,klev,tra(1:klev,18),'tra18','tra18')
+c@$$          call writeg1d(1,klev,tra(1:klev,19),'tra19','tra19')
+c@$$          call writeg1d(1,klev,tra(1:klev,20),'tra20','tra20 ')
+c@$$          call writeg1d(1,klev,trap(1:klev,1),'trp1','trp1')
+c@$$          call writeg1d(1,klev,trap(1:klev,2),'trp2','trp2')
+c@$$          call writeg1d(1,klev,trap(1:klev,3),'trp3','trp3')
+c@$$          call writeg1d(1,klev,trap(1:klev,4),'trp4','trp4')
+c@$$          call writeg1d(1,klev,trap(1:klev,5),'trp5','trp5')
+c@$$          call writeg1d(1,klev,trap(1:klev,10),'trp10','trp10')
+c@$$          call writeg1d(1,klev,trap(1:klev,12),'trp12','trp12')
+c@$$          call writeg1d(1,klev,trap(1:klev,15),'trp15','trp15')
+c@$$          call writeg1d(1,klev,trap(1:klev,20),'trp20','trp20')
+c@$$          call writeg1d(1,klev,ftra(1:klev,1),'ftr1  ','ftr1  ')
+c@$$          call writeg1d(1,klev,ftra(1:klev,2),'ftr2  ','ftr2  ')
+c@$$          call writeg1d(1,klev,ftra(1:klev,3),'ftr3  ','ftr3  ')
+c@$$          call writeg1d(1,klev,ftra(1:klev,4),'ftr4  ','ftr4  ')
+c@$$          call writeg1d(1,klev,ftra(1:klev,5),'ftr5  ','ftr5  ')
+c@$$          call writeg1d(1,klev,ftra(1:klev,6),'ftr6  ','ftr6  ')
+c@$$          call writeg1d(1,klev,ftra(1:klev,7),'ftr7  ','ftr7  ')
+c@$$          call writeg1d(1,klev,ftra(1:klev,8),'ftr8  ','ftr8  ')
+c@$$          call writeg1d(1,klev,ftra(1:klev,9),'ftr9  ','ftr9  ')
+c@$$          call writeg1d(1,klev,ftra(1:klev,10),'ftr10','ftr10')
+c@$$          call writeg1d(1,klev,ftra(1:klev,11),'ftr11','ftr11')
+c@$$          call writeg1d(1,klev,ftra(1:klev,12),'ftr12','ftr12')
+c@$$          call writeg1d(1,klev,ftra(1:klev,13),'ftr13','ftr13')
+c@$$          call writeg1d(1,klev,ftra(1:klev,14),'ftr14','ftr14')
+c@$$          call writeg1d(1,klev,ftra(1:klev,15),'ftr15','ftr15')
+c@$$          call writeg1d(1,klev,ftra(1:klev,16),'ftr16','ftr16')
+c@$$          call writeg1d(1,klev,ftra(1:klev,17),'ftr17','ftr17')
+c@$$          call writeg1d(1,klev,ftra(1:klev,18),'ftr18','ftr18')
+c@$$          call writeg1d(1,klev,ftra(1:klev,19),'ftr19','ftr19')
+c@$$          call writeg1d(1,klev,ftra(1:klev,20),'ftr20','ftr20 ')
+c@$$          call writeg1d(1,klev,mp,'mp  ','mp ')
+c@$$          call writeg1d(1,klev,Mke,'Mke  ','Mke ')
 
  
Index: /LMDZ4/trunk/libf/phylmd/cv_driver.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/cv_driver.F	(revision 765)
+++ /LMDZ4/trunk/libf/phylmd/cv_driver.F	(revision 766)
@@ -11,4 +11,5 @@
      &                   da1,phi1,mp1)
 C
+      USE dimphy
       implicit none
 C
@@ -64,6 +65,6 @@
 c
 c
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 
       integer len
@@ -250,7 +251,7 @@
 c (local) compressed fields:
 c
-      integer nloc
-      parameter (nloc=klon) ! pour l'instant
-
+cym      integer nloc
+cym      parameter (nloc=klon) ! pour l'instant
+#define nloc klon
       integer idcum(nloc)
       integer iflag(nloc),nk(nloc),icb(nloc)
@@ -290,4 +291,5 @@
       real wd(nloc)           ! gust
 
+      nent(:,:)=0
 !-------------------------------------------------------------------
 ! --- SET CONSTANTS AND PARAMETERS
Index: /LMDZ4/trunk/libf/phylmd/cvflag.h
===================================================================
--- /LMDZ4/trunk/libf/phylmd/cvflag.h	(revision 765)
+++ /LMDZ4/trunk/libf/phylmd/cvflag.h	(revision 766)
@@ -5,2 +5,3 @@
 
       COMMON /cvflag/ cvflag_grav 
+c$OMP THREADPRIVATE(/cvflag/)
Index: /LMDZ4/trunk/libf/phylmd/cvltr.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/cvltr.F	(revision 765)
+++ /LMDZ4/trunk/libf/phylmd/cvltr.F	(revision 766)
@@ -3,4 +3,5 @@
 c
       SUBROUTINE cvltr(pdtime,da, phi, mp,paprs,pplay,x,upd,dnd,dx)
+      USE dimphy
       IMPLICIT NONE 
 c=====================================================================
@@ -9,6 +10,6 @@
 c=====================================================================
 c
-#include "dimensions.h"
-#include "dimphy.h"
+cym#include "dimensions.h"
+cym#include "dimphy.h"
 #include "YOMCST.h"
 #include "YOECUMF.h" 
Index: /LMDZ4/trunk/libf/phylmd/cvparam.h
===================================================================
--- /LMDZ4/trunk/libf/phylmd/cvparam.h	(revision 765)
+++ /LMDZ4/trunk/libf/phylmd/cvparam.h	(revision 766)
@@ -27,2 +27,3 @@
      :                ,dtmax, cu, betad, alpha, damp, delta
 
+c$OMP THREADPRIVATE(/cvparam/)
Index: /LMDZ4/trunk/libf/phylmd/cvparam3.h
===================================================================
--- /LMDZ4/trunk/libf/phylmd/cvparam3.h	(revision 765)
+++ /LMDZ4/trunk/libf/phylmd/cvparam3.h	(revision 766)
@@ -28,2 +28,3 @@
      :                ,dtcrit, tau, beta, alpha, delta, betad
 
+c$OMP THREADPRIVATE(/cvparam3/)
Index: /LMDZ4/trunk/libf/phylmd/cvthermo.h
===================================================================
--- /LMDZ4/trunk/libf/phylmd/cvthermo.h	(revision 765)
+++ /LMDZ4/trunk/libf/phylmd/cvthermo.h	(revision 766)
@@ -14,2 +14,3 @@
      :                 ,eps, epsi, epsim1, ginv, hrd, grav
 
+c$OMP THREADPRIVATE(/cvthermo/)
Index: /LMDZ4/trunk/libf/phylmd/diagphy.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/diagphy.F	(revision 765)
+++ /LMDZ4/trunk/libf/phylmd/diagphy.F	(revision 766)
@@ -74,4 +74,5 @@
       save pas
       data pas/0/
+c$OMP THREADPRIVATE(pas)
 C
       pas=pas+1
@@ -258,4 +259,5 @@
       save pas
       data pas/ndiag*0/
+c$OMP THREADPRIVATE(pas)
 C     
       REAL      h_vcol_pre(ndiag), h_dair_pre(ndiag), h_qw_pre(ndiag)
@@ -264,5 +266,6 @@
       SAVE      h_vcol_pre, h_dair_pre, h_qw_pre, h_ql_pre
      $        , h_qs_pre, qw_pre, ql_pre, qs_pre , ec_pre
-
+c$OMP THREADPRIVATE(h_vcol_pre, h_dair_pre, h_qw_pre, h_ql_pre)
+c$OMP THREADPRIVATE(h_qs_pre, qw_pre, ql_pre, qs_pre , ec_pre)
 c======================================================================
 C
Index: /LMDZ4/trunk/libf/phylmd/dimphy.F90
===================================================================
--- /LMDZ4/trunk/libf/phylmd/dimphy.F90	(revision 765)
+++ /LMDZ4/trunk/libf/phylmd/dimphy.F90	(revision 766)
@@ -1,321 +1,4 @@
 module dimphy
-
-  
-  logical, save :: monocpu
-!  logical, save :: parallel
-   
-  INTEGER,SAVE :: iiphy_begin
-  INTEGER,SAVE :: iiphy_end
-  INTEGER,SAVE :: jjphy_begin
-  INTEGER,SAVE :: jjphy_end
-  INTEGER,SAVE :: jjphy_nb
-  INTEGER,SAVE :: ijphy_begin
-  INTEGER,SAVE :: ijphy_end
-  INTEGER,SAVE :: ijphy_nb
-  INTEGER,SAVE :: klon_begin
-  INTEGER,SAVE :: klon_end
-  
-  
-  INTEGER,SAVE,allocatable,dimension(:) :: jjphy_para_nb
-  INTEGER,SAVE,allocatable,dimension(:) :: jjphy_para_begin
-  INTEGER,SAVE,allocatable,dimension(:) :: jjphy_para_end
-  INTEGER,SAVE,dimension(:),allocatable :: Liste_i
-  INTEGER,SAVE,dimension(:),allocatable :: Liste_j
-  INTEGER,SAVE,dimension(:),allocatable :: klon_para_nb
-  INTEGER,SAVE,dimension(:),allocatable :: klon_para_begin
-  INTEGER,SAVE,dimension(:),allocatable :: klon_para_end 
-
-  
-  INTEGER,save :: phy_rank
-  INTEGER,save :: phy_size
-  
-
-  INTEGER,save :: klev, klevp1,klevm1,klon,kfdia,kidia
-  INTEGER,save :: klon2
-  INTEGER,save :: nbtr 
-  INTEGER,save :: kdlon, kflev
-  REAL,save,allocatable,dimension(:) :: zmasq
-  
-
-  
-contains
-  
-   subroutine InitDimphy
-
-#ifdef CPP_PARALLEL
-   use parallel
-#endif
-
-   implicit none
-#include "dimensions90.h"
-#include "paramet90.h" 
-    integer :: rank
-    integer :: i,j,Pos,Index
-    logical,save :: First=.true.
-#ifndef CPP_PARALLEL
-   logical, save :: pole_nord = .true.
-   logical, save :: pole_sud = .true.
-#endif
-
-#ifdef CPP_PARALLEL      
-      monocpu=.false.
-#else
-      monocpu = .true.
-#endif
-      
-      if (monocpu) then
-        
-	phy_rank=0
-	phy_size=1
-	
-#ifdef CPP_PARALLEL      
-      else
- 
-        phy_rank=mpi_rank
-	phy_size=mpi_size
-#endif
-      
-      endif
-
-      if (First) then
-        allocate(jjphy_para_nb(0:phy_size-1))
-        allocate(jjphy_para_begin(0:phy_size-1))
-        allocate(jjphy_para_end(0:phy_size-1))
-        allocate(klon_para_nb(0:phy_size-1))
-        allocate(klon_para_begin(0:phy_size-1))
-        allocate(klon_para_end(0:phy_size-1))
-      endif
-	
-      klev=llm
-      klevp1=klev+1
-      klevm1=klev-1
-      klon2=iim*(jjm-1)+2
-      
-     
-!        do i=0,phy_size-1
-!          klon_para_nb(i)=(klon2/phy_size)
-!          if (i<MOD(klon2,phy_size)) klon_para_nb(i)=klon_para_nb(i)+1
-!          if (i==0) then 
-!            klon_para_begin(i)=1
-!          else 
-!            klon_para_begin(i)=klon_para_end(i-1)+1
-!          endif
-!          klon_para_end(i)=klon_para_begin(i)+klon_para_nb(i)-1
-!        enddo
-      
-      if (First) then
-        do i=0,phy_size-1
-          klon_para_nb(i)=(klon2/phy_size)
-          if (i<MOD(klon2,phy_size)) klon_para_nb(i)=klon_para_nb(i)+1
-        enddo
-      endif
-        
-      do i=0,phy_size-1
-        if (i==0) then 
-          klon_para_begin(i)=1
-        else 
-          klon_para_begin(i)=klon_para_end(i-1)+1
-        endif
-        klon_para_end(i)=klon_para_begin(i)+klon_para_nb(i)-1
-      enddo
-	
-      klon=klon_para_nb(phy_rank)
-      klon_begin=klon_para_begin(phy_rank)
-      klon_end=klon_para_end(phy_rank)
-	
-      nbtr=nqmx-2+1/(nqmx-1)
-
-      kidia=1
-      kfdia=klon
-      
-      if (klon==6818 .and. monocpu) then
-        kdlon=487
-      else
-        kdlon=klon
-      endif
-      kflev=klev
-    
-      if (.not.first) then
-        deallocate(zmasq,liste_i,liste_j)
-      endif
-      
-      allocate(zmasq(klon))
-
-      
-      allocate(Liste_i(klon))
-      allocate(Liste_j(klon))
-    
-      Index=1
-      if (Pole_Nord) then
-        Liste_i(1)=1
-        Liste_j(1)=1
-        iiphy_begin=1
-        jjphy_begin=1
-	ijphy_begin=1
-        Index=Index+1
-      endif
-    
-      Pos=2
-      do j=2,jjm
-        do i=1,iim
-      
-	  if (Pos==klon_begin) then
-            iiphy_begin=i
-            jjphy_begin=j
-	    ijphy_begin=j*iip1+i
-          endif
-       
-          if (Pos==klon_end) then
-            iiphy_end=i
-            jjphy_end=j
-	    ijphy_end=j*iip1+i
-          endif
-        
-          if (Pos>=klon_begin .AND. Pos<=klon_end) then
-            Liste_i(Index)=i
-            Liste_j(Index)=j
-            Index=Index+1
-          endif
-          Pos=Pos+1
-        enddo
-      enddo
-    
-      if (pole_sud) then
-        Liste_i(Index)=1
-        Liste_j(Index)=jjp1
-        iiphy_end=1
-        jjphy_end=jjp1
-	ijphy_end=jjp1*iip1+1
-      endif
-    
-      ijphy_nb=ijphy_end-ijphy_begin+1
-      jjphy_nb=jjphy_end-jjphy_begin+1
-	
-	    
-      Pos=2
-      rank=0
-      jjphy_para_begin(rank)=1
-    
-      do j=2,jjm
-        do i=1,iim
-          if (Pos==klon_para_begin(rank)) then
-            jjphy_para_begin(rank)=j
-          endif
-          if (Pos==klon_para_end(rank)) then
-            jjphy_para_end(rank)=j
-            rank=rank+1
-          endif
-          Pos=Pos+1
-        enddo
-      enddo
-      jjphy_para_end(rank)=jjp1
-      
-      First=.false.    
-   end subroutine InitDimphy
-   
-
-   subroutine GatherField(Fields,Fieldr,ll)
-     implicit none
-#ifdef CPP_PARALLEL      
-     include 'mpif.h'
-#endif
-     INTEGER :: ll
-     REAL, dimension(klon,ll) :: Fields
-     REAL, dimension(klon2,ll) :: Fieldr     
-     REAL, dimension(klon2*ll) :: Field_tmp     
-     INTEGER, dimension(0:phy_size-1) :: displs
-     INTEGER, dimension(0:phy_size-1) :: sendcounts
-     INTEGER :: l,Pos,rank,ierr
-     INTEGER :: klon_b,klon_e, Nb
-     
-     Pos=1     
-     do rank=0,phy_size-1
-       klon_b=klon_para_begin(rank)
-       klon_e=klon_para_end(rank)
-       Nb=klon_para_nb(rank)
-       displs(rank)=Pos-1
-       sendcounts(rank)=Nb*ll
-       Pos=Pos+Nb*ll
-     enddo
-         
-      if (monocpu) then
-        Fieldr(:,:)=Fields(:,:)
-#ifdef CPP_PARALLEL      
-      else
-        call MPI_Gatherv(Fields,klon*ll,MPI_REAL8,Field_tmp,sendcounts,  &
-	                 displs,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
-#endif
-      endif
-      
-     Pos=1     
-     do rank=0,phy_size-1
-       klon_b=klon_para_begin(rank)
-       klon_e=klon_para_end(rank)
-       Nb=klon_para_nb(rank)
-       do l=1,ll
-         Fieldr(klon_b:klon_e,l)=Field_tmp(Pos:Pos+Nb-1)
-	 Pos=Pos+Nb
-       enddo
-     enddo
-      
-   end subroutine GatherField
-
-   subroutine AllGatherField(Fields,Fieldr,ll)
-     implicit none
-#ifdef CPP_PARALLEL      
-     include 'mpif.h'
-#endif   
-     INTEGER :: ll
-     REAL, dimension(klon,ll) :: Fields
-     REAL, dimension(klon2,ll) :: Fieldr     
-     
-     INTEGER :: ierr
-
-#ifdef CPP_PARALLEL             
-     call GatherField(Fields,Fieldr,ll)
-     call MPI_BCAST(Fieldr,klon2*ll,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
-#endif   
-   end subroutine AllGatherField
-   
-           
-   subroutine ScatterField(Fields,Fieldr,ll)
-     implicit none
-#ifdef CPP_PARALLEL      
-     include 'mpif.h'
-#endif
-     INTEGER :: ll
-     REAL, dimension(klon2,ll) :: Fields
-     REAL, dimension(klon,ll) :: Fieldr     
-     REAL, dimension(klon2*ll) :: Field_tmp     
-     INTEGER, dimension(0:phy_size-1) :: displs
-     INTEGER, dimension(0:phy_size-1) :: sendcounts
-     INTEGER :: l,Pos,rank,ierr
-     INTEGER :: klon_b,klon_e, Nb
-
-     Pos=1    
-     do rank=0,phy_size-1
-       klon_b=klon_para_begin(rank)
-       klon_e=klon_para_end(rank)
-       Nb=klon_para_nb(rank)
-       displs(rank)=Pos-1
-       sendcounts(rank)=Nb*ll
-       do l=1,ll
-         Field_tmp(Pos:Pos+Nb-1)=Fields(klon_b:klon_e,l)
-	 Pos=Pos+Nb
-       enddo
-     enddo
-           
-     if (monocpu) then
-       Fieldr(:,:)=Fields(:,:)
-     else
-#ifdef CPP_PARALLEL      
-       call MPI_Scatterv(Field_tmp,sendcounts,displs,MPI_REAL8,         &
-	                 Fieldr,klon*ll,MPI_REAL8,0,MPI_COMM_WORLD,ierr)
-#endif
-     endif
-      
-        
-   end subroutine ScatterField
-   
-   
+  USE mod_phys_mpi
+  USE mod_phys_openmp
 end module dimphy
